"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.scanSync = void 0;
var fs_1 = require("@beenotung/tslib/fs");
var fs = require("fs");
var path = require("path");
var ts = require("typescript");
function scanSync(entryPath, ext) {
    return (0, fs_1.scanRecursivelySync)({
        entryPath: entryPath,
        dereferenceSymbolicLinks: true,
        skipDir: function (dirname, basename) {
            return basename === 'node_modules' && dirname.includes('node_modules');
        },
        onFile: function (inFilename, inBasename) {
            if (!inBasename.endsWith('.macro.ts')) {
                return;
            }
            console.log('expanding', inFilename);
            var outBasename = inBasename.replace(/\.macro\.ts$/, ext);
            var dirname = path.dirname(inFilename);
            var outFilename = path.join(dirname, outBasename);
            var inText = fs.readFileSync(inFilename).toString();
            /* override require to support importing relative files and local packages from macro */
            var realDirname = path.resolve(dirname);
            var realRequire = require;
            if (inFilename.endsWith('.ts')) {
                require('ts-node/register');
            }
            require = Object.assign(function (id) {
                id = realRequire.resolve(id, { paths: [realDirname] });
                return realRequire(id);
            }, realRequire);
            /* tslint:disable-next-line no-eval */
            var outText = eval(ts.transpile(inText));
            require = realRequire;
            fs.writeFileSync(outFilename, outText);
        },
    });
}
exports.scanSync = scanSync;
//# sourceMappingURL=scanner.js.map